/******************************************************************************************
   By Navid Hamed Azimi
   The general Control Panel of Short Assembly
/******************************************************************************************/

#ifndef NavidShortAssemblyControlPanel
#define NavidShortAssemblyControlPanel

#include <string>
using namespace std;

#define alphabetNumber 4
#define depthFromRootAlwaysInMemory 1




/*******************************************
This is the alphabet that is used in reads ,THEY SHOULD BE SORTED BASED ON compareNucleotide FUNCTION
/********************************************/

enum  leftOrRightEnum {leftHead,rightHead};
//const char alphabet[alphabetNumber]={'A','C','G','T','?','-'};
const char alphabet[alphabetNumber]={'A','C','G','T'};

/*******************************************
This is a macro that is used for alphabet comparison. It is defined as inline for speed.
/********************************************/
inline int getIndex(char a) {
 for(int i=0;i<alphabetNumber;i++)
	if (alphabet[i]==a) return i;
	throw "There is a character in the reads that is not is the alphabets";
}

inline int missMatchNumber(const std::string& s, const string& substr, int index,int error) {
	int temp=0;
	if (index+substr.length()<=s.length()) {
		for (unsigned int i=0; i < substr.length(); i++) {
			if (s[i+index]!=substr[i]) {
				temp++;
				if (temp>error)  return 1999999999;
			}
		}
		return temp;
	}
	return 1999999999;
}


inline int compareNucleotide(char a,char b) {

	if (a=='?') return -2;
	if (b=='?') return 2;
	if (a=='_') return -3;
	if (b=='_') return 3;
	if (a==b)   return 0;
	if (a<b)    return -1;
	return 1;
}
inline char getReverse(char ch) {
	if (ch=='A') { return 'T'; }
	if (ch=='T') { return 'A'; }
	if (ch=='G') { return 'C'; }
	if (ch=='C') { return 'G'; }
	return 'A';
}

// string getReverseComplement(string s) {
// 		string t;
// 		int y=s.length();
// 		t.resize(y);
// 		y--;
// 		for (int i = 0; i <(signed int)(s.length()); i++) {
// 			t[i]=getReverse(s[y-i]);
// 		}
// 		return t;
// }
#endif
