/******************************************************************************************
   Class Trie and Node By Navid Hamed Azimi
   This class is supposed to get a large list of pointers to an string and create, insert,search,
   and maintain a trie of all of the strings. The trie is supposed to search only the whole strings,
   It does not have the ability to search substrings.

   Class Node is supposed to be a Node of the Trie.

   myList is a link list to store the strings at the end of each trie, The reason for not using stl is memory and speed.
   each vector or other stl classes has minimum 40 byte overhead but mylist only have a size of a pointer overhead which is 8 or 4.
   Since by the calculations most of the time it will only contain one string and it will never grow more than 4 or five so we don't need
   the length parameter as well.

/******************************************************************************************/
#ifndef NavidTrieClass
#define NavidTrieClass

#include <string>
#include <vector>


#include "header.h"
#include "ControlPanel.cc"
#include "pointer.cc"
#include "read-processor.h"



// reportingDebug1 turn on a counter that show the status of building the first blocks of the trie.
#define  reportingDebug1



using namespace std;
class TrieNode;
class myList;

#ifndef nodeTemp
static   TrieNode* nodeTemp;
#endif

#ifndef listTemp
static ptr<myList>* listTemp;
#endif
#ifndef stringtemp
static string stringtemp="";
#endif

namespace ReadsVectorSpace {
  #ifndef readsVect
  static ReadProcessor* readsVect;
  #endif
}


class readPointer {
	public :
		mar_types  status;
		int ID;
		readPointer() {
			ID=-1;
		}
		inline const string& stringData() {
			if (ID==-1) { return stringtemp; }
			return ReadsVectorSpace::readsVect->GetMar(ID,status);
/*			if (status==1)
				return readsVect->GetLMar(ID,LMAR);
			if (status==2)
				return readsVect->GetLMar(ID,RMAR);
			if (status==3)
				return readsVect->GetLMar(ID,LMARRC);
			if (status==4)
				return readsVect->GetLMar(ID,RMARRC);/*/
//			throw "error in assigning status to read pointer";
		};
		inline string toStream() {
			char buffer[50];
			sprintf(buffer,"%d %d",ID,status);
			string s=buffer;
			return s;
		}
};


class myList {
	   public:
	   readPointer data;
	   ptr<myList> next;
	   #define myListStartTag -1
	   #define myListEndTag -2
		bool checkString(string s, int index,int missMatchesAllowed) {
			string t=s.substr(index,1000);
			if (this->data.stringData().length()!=s.length()) { return false;}
			if (missMatchNumber(this->data.stringData(), t, index,missMatchesAllowed)>missMatchesAllowed) return false;
		   return true;
	   }
	   myList(){
				next=NULL;
	   };
           myList(const myList& inp1){
	     data=inp1.data;
	     next=inp1.next;
	   }
	   myList(readPointer input) {
				next=NULL;
				data=input;
	   };
	   int size() {
			if (data.ID==-1)  return 0;
			ptr<myList> temp=next;
			int size=1;
			while (temp!=NULL) {
				temp=temp->next;
				size++;
			}
			return size;
	   }
	   inline bool isEmpty() {
					 if (data.ID==-1)
						return true;
					 else
						return false;
	   };

	   void addToList(readPointer input) {
			if (input.ID==-1) return;
			if (data.ID==-1)  { data=input; return; }
			ptr<myList> temp=NULL;
			temp->data=input;
			temp->next=NULL;
			addToList(temp);
	   };
	   void addToList(ptr<myList> input) {
			if (input==NULL) return;
			if (input->data.ID==-1) return;
			if (data.ID==-1)  {
				data=input->data;
				next=input->next;
				return;
			}
			else if (next==NULL){
				next=input;
			} else {
				ptr<myList> temp=next;
				while (temp->next!=NULL) temp=temp->next;
				temp->next=input;
			}
	   };
}; // enf of mylist class
#ifndef counter
static int counter=0;
#endif
static int secondcounter=0;
class TrieNode  {
	  public:
	  #define TrieNodeStartTag -3
	  #define TrieNodeEndTag -4
	  bool isChildLeaf[alphabetNumber];
	  string theEdge;
	  void* childs[alphabetNumber];
	  TrieNode(){
			for (int i = 0; i <alphabetNumber; i++) {
				this->isChildLeaf[i]=true;
				this->childs[i]=NULL;
			}
	  };
	  //Copy Constructor
	  TrieNode(const TrieNode& inp) {
			throw "you cannot use copy constructor for this object";
	  };

	//Destructor Free the Nodes;
	  ~TrieNode() {
	  //	destructNode();
	  }
	  void destructNode() {
		  for (int i = 0; i <alphabetNumber; i++) {
			if (this->isChildLeaf[i]) {
				listTemp=(ptr<myList>*)this->childs[i];
				listTemp->free();
				delete listTemp;
			}
			else {
				nodeTemp=(TrieNode*)this->childs[i];
				delete nodeTemp;
//				delete nodeTemp;
			}
		  }//*/
	  };

	  void addPairReadToTrie(int ID) {
			readPointer temp;
			temp.ID=ID;
			temp.status=LMAR;
			addToTrie(temp);
			temp.status=RMAR;
			addToTrie(temp);
			temp.status=LMARRC;
			addToTrie(temp);
			temp.status=RMARRC;
			addToTrie(temp);
	  }
	  void addPairReadToRightTrie(int ID) {
			readPointer temp;
			temp.ID=ID;
			temp.status=RMAR;
			addToTrie(temp);
			temp.status=RMARRC;
			addToTrie(temp);
	  }	 
          void addPairReadToLeftTrie(int ID) {
			readPointer temp;
			temp.ID=ID;
			temp.status=LMAR;
			addToTrie(temp);
			temp.status=LMARRC;
			addToTrie(temp);
	  }

	  void constructTrie() {
	    int j=ReadsVectorSpace::readsVect->TotalPairs();
	    cout<<endl<<"number of reads added to Tire"<<ReadsVectorSpace::readsVect->TotalPairs()<<endl;
		for (int i=0; i <j; i++)
			addPairReadToTrie(i);
	  }

	  void constructLeftTrie() {
	    int j=ReadsVectorSpace::readsVect->TotalPairs();
		for (int i=0; i <j; i++)
			addPairReadToLeftTrie(i);
	  }
	  void constructRightTrie() {
	    int j=ReadsVectorSpace::readsVect->TotalPairs();
		for (int i=0; i <j; i++)
			addPairReadToRightTrie(i);
	  }
	   vector<readPointer> searchWithError(string s,int errorAllowed,int index=0) {
			vector<readPointer> result;
			ptr<myList> temp=searchWithErrorAllowed(s,errorAllowed,index);
			ptr<myList> temp2=temp;
			cout<<"search resulte in "<<temp2->size()<<" matches";
			int tt=temp2->size();
			result.resize(tt);
			if (temp2->data.ID==-1)  return result;
			for (int i=0; i < tt; i++) {
				result[i]=temp2->data;
				temp=temp2->next;
			}
			return result;
	   }

	   ptr<myList> searchWithErrorAllowed(string s,int& errorAllowed,int index=0) {
        	counter++;
//		   int lengthTemp=this->theEdge.length();
// 		   cout<<endl<<"the edge is "<<this->theEdge<<" error is "<<errorAllowed;    
		   int indexLengthTemp=index+this->theEdge.length();
		   if (indexLengthTemp>=(signed int)s.length()) { return NULL;}
		   int errorRemained=errorAllowed-missMatchNumber(s,this->theEdge,index,errorAllowed);
		   if (errorRemained<0) return NULL;
		   if (errorRemained<=0) {
					int i=getIndex(s[indexLengthTemp]);
					if (this->childs[i]==NULL) return NULL;
					if (this->isChildLeaf[i]) {
						listTemp=(ptr<myList>*)(this->childs[i]);
						//    	cout<<endl<<"the string is "<<(*listTemp)->data.stringData();
						//	cout<<endl<<" the search string is "<<s;
						
						int tm;
						//						cin>>tm;
						if ((*listTemp)->checkString(s,indexLengthTemp,errorRemained)) {
						  cout<<endl<<"HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH"<<endl;
							return (*listTemp);
						}
					}
					else {
						nodeTemp=(TrieNode*)(this->childs[i]);
						return nodeTemp->searchWithErrorAllowed(s,errorRemained,indexLengthTemp);
					}

		   } else {
			   ptr<myList> results=NULL;
			   //int errorTemp=errorRemained;
			   for (int j = 0; j <alphabetNumber; j++) {
					if (this->childs[j]!=NULL) {
						if (this->isChildLeaf[j]) {
							listTemp=(ptr<myList>*)(this->childs[j]);
							if ((*listTemp)->checkString(s,indexLengthTemp,errorRemained))
								results->addToList(*listTemp);
							}
							else {
								nodeTemp=(TrieNode*)(this->childs[j]);
								results->addToList(nodeTemp->searchWithErrorAllowed(s,errorRemained,indexLengthTemp));
							}
					}
			   }
			   cout<<endl<<"number of strings find is "<<results->size();
			   return results;
		   }
		   return NULL;

	   };

	   void addToTrie(ptr<myList> inp1, int index=0) {
	     
				if (inp1->data.stringData().length()<5) {
				  //cout << "got length: " << inp1->data.stringData().length() << endl;
				  throw "error you shouldn't add strings of less than size 5 to trie";	  
				}
				int t=getIndex(inp1->data.stringData()[index]);
				listTemp=(ptr<myList>*)this->childs[t];
				if (this->childs[t]==NULL) {
					this->isChildLeaf[t]=true;
					listTemp=new ptr<myList>();
					*listTemp=inp1;
					this->childs[t]=listTemp;
					secondcounter++;
					return;
				} else if (this->isChildLeaf[t]) {
					int ti=index;
					for (ti=index; ti <(signed int)inp1->data.stringData().length(); ti++) {
						if 	(compareNucleotide(
												(*listTemp)->data.stringData()[ti],
												inp1->data.stringData()[ti]
											   )!=0
							)
						 break;
					}
					if (ti==(signed int)inp1->data.stringData().length()) {
						(*listTemp)->addToList(inp1);
						secondcounter++;
						return;

					} else {
						nodeTemp=new TrieNode();
						this->childs[t]=(void*)nodeTemp;
						this->isChildLeaf[t]=false;
						nodeTemp->theEdge=inp1->data.stringData().substr(index,ti-index);
						int si=getIndex(inp1->data.stringData()[ti]);
						int fi=getIndex((*listTemp)->data.stringData()[ti]);
						if (si==fi) throw("Error in compare Nucleotide function check it out");
						nodeTemp->childs[fi]=(void*)listTemp;
						listTemp= new ptr<myList>();
						*listTemp=inp1;
						secondcounter++;
						nodeTemp->childs[si]=(void*)listTemp;
					}
					return;
				}
				TrieNode* nodeTemp2=(TrieNode*)this->childs[t];
					int ti=index;
					int minLength=min(nodeTemp2->theEdge.length(),inp1->data.stringData().length()-index);
					for (ti=index; ti <index+minLength; ti++) {
						if 	(compareNucleotide(
												nodeTemp2->theEdge[ti-index],
												inp1->data.stringData()[ti]
											   )!=0
							)
						 break;
					}
					if (ti==minLength+index) {
						nodeTemp2->addToTrie(inp1,ti);
						return;
					}
					else {
						string tempstr=nodeTemp2->theEdge;
						nodeTemp=new TrieNode();
						this->childs[t]=(void*)nodeTemp;
						this->isChildLeaf[t]=false;
						nodeTemp->theEdge=inp1->data.stringData().substr(index,ti-index);
						int si=getIndex(inp1->data.stringData()[ti]);
						int fi=getIndex(nodeTemp2->theEdge[ti-index]);
						if (si==fi) throw("Error in compare Nucleotide function check it out");
						nodeTemp->childs[fi]=(void*)nodeTemp2;
						nodeTemp->isChildLeaf[fi]=false;
						nodeTemp2->theEdge=tempstr.substr(ti-index,1000);
						listTemp = new ptr<myList>();
						*listTemp = inp1;
						secondcounter++;
						nodeTemp->childs[si]=(void*)listTemp;
						nodeTemp->isChildLeaf[si]=true;
					}
	   } // end of main add to tire function
	   inline void addToTrie(readPointer inp1,int index=0) {
			ptr<myList> temp;
			//	cout<<"length step 1"<<inp1.stringData().length()<<" ID is  "<<inp1.ID<<" ";
			temp->data=inp1;
			addToTrie(temp,index);
	   }

}; //end of Trie Node Class

#endif
