#ifndef CLUSTER_H
#define CLUSTER_H

#include "header.h"
#include "macros.h"

// Cluster of mars. At present, it only contains either left or right mars.
class Cluster {
 public:
  inline void AddIndex(int i, int g, mar_types mt) {
    indices_.push_back(i);
    //    offsets_.push_back(o);
    gens_.push_back(g);
    //mars_.push_back(mar);
    mar_types_.push_back(mt);
  }
  inline const IntVec& Indices() const { return indices_; }
  inline int GetIndex(int i) const { return indices_[i]; }
  //inline int GetOffset(int i) const { return offsets_[i]; }
  inline int GetGen(int i) const { return gens_[i]; }
  //inline const string& GetMar(int i) const { return mars_[i]; }
  inline const mar_types GetMt(int i) const { return mar_types_[i]; }
  inline int Size() const { return indices_.size(); }

 private:

  // Reads at these indices are included in the cluster.
  IntVec indices_;

  // Position on the seed of the anchor mar corresponding to this pair.
  //IntVec offsets_;

  // Generation IDs of the mars.
  IntVec gens_;

  // Indicates the type of mars we have.
  MtVec mar_types_;
};

#endif  //  CLUSTER_H
