// Declaration of essential stl classes, typedefs, templates, etc.

#ifndef HEADER_H
#define HEADER_H

#include <algorithm>
#include <bitset>
#include <cassert>
//#include <functional>
//#include <iostream>
#include <iterator>
#include <list>
#include <map>
#include <memory>
#include <hash_map>
#include <stack>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

// A big number
const int INF = 1000000000;

const int MAX_CHAR = 1 << 8;

// Defined templates.
template <class T>
class Constant {
 public:
 Constant() : initialized_(false) {}
  void operator = (const T& data) {
    //    assert(initialized_ == false);
    initialized_ = true;
    data_ = data;
  }
  const T& Data() const { return data_; }
  //bool operator == (const T& data) const { return data == data_; }
  //bool operator < (const T& data) const { return data_ < data; }
  //  bool operator > (const T& data) const { return data_ > data; }
  friend ostream& operator << (ostream& os, const Constant<T>& ss) {
    os << ss.Data();
  }
 
 private:
  Constant(const Constant<T>& t);
  T data_;
  bool initialized_;
};

/* template<class T> */
/* bool operator < (const T& t, const Constant<T>& c) { */
/*   return t < c.Data(); */
/* } */

/* template<class T> */
/* bool operator >= (const T& t, const Constant<T>& c) { */
/*   return t >= c.Data(); */
/* } */

/* template<class T> */
/* bool operator <= (const T& t, const Constant<T>& c) { */
/*   return t <= c.Data(); */
/* } */

/* template<class T> */
/* bool operator * (const T& t, const Constant<T>& c) { */
/*   return t * c.Data(); */
/* } */

/* template<class T> */
/* bool operator * (const Constant<T>& t, const Constant<T>& c) { */
/*   return t.Data() * c.Data(); */
/* } */

/* template<class T> */
/* bool operator + (const T& t, const Constant<T>& c) { */
/*   return t + c.Data(); */
/* } */

template <class T1, class T2, class T3>
class triple {
 public:
  triple() {}
  triple(T1 a, T2 b, T3 c) : first(a), second(b), third(c) {}
  T1 first;
  T2 second;
  T3 third;
};

template <class T1, class T2, class T3, class T4>
class quad {
 public:
  quad(T1 a, T2 b, T3 c, T4 d) : first(a), second(b), third(c), fourth(d) {}
  T1 first;
  T2 second;
  T3 third;
  T4 fourth;
};

// enums
// # of mar types we use.
const int MAR_TYPES = 4;//8;

// Define the mar types
//enum mar_types                 {LMAR = 0, RMAR, LMARRC, RMARRC, LMARQ, RMARQ, LMARQRC, RMARQRC};
enum mar_types                 {LMAR = 0, RMAR, LMARRC, RMARRC};

// Define the corresponding pair
//const mar_types mar_type_pair [] = {RMAR, LMAR, RMARRC, LMARRC, RMARQ, LMARQ, RMARQRC, LMARQRC};
const mar_types mar_type_pair [] = {RMAR, LMAR, RMARRC, LMARRC};

// Define bases.
const int BASE_TYPES = 4;

enum base_types {BASEA = 0, BASET, BASEG, BASEC};

// typedefs..
typedef short int sint;
typedef vector<int> IntVec;
typedef vector<short int> ShortIntVec;
typedef list<int> IntList;
typedef vector<string> StrVec;
typedef pair<int, int> IntPair;
typedef triple<int, int, int> IntTriple;
typedef vector<IntTriple> IntTripleVec;
typedef vector<IntPair> IntPairVec;
typedef pair<int, mar_types> IntMtPair;
typedef vector<IntMtPair> IntMtPairVec; 
typedef pair<string, int> StrIntPair;
typedef vector<StrIntPair> StrIntPairVec;
typedef quad<string, int, int, int> StrIntIntIntQuad;
typedef vector<StrIntIntIntQuad> StrIntIntIntQuadVec;
typedef quad<int, int, string, string> IntIntStrStrQuad;
typedef vector<IntIntStrStrQuad> IntIntStrStrQuadVec;
typedef triple<int, int, mar_types> IntIntMtTriple;
typedef vector<IntIntMtTriple> IntIntMtTripleVec;
typedef vector<mar_types> MtVec;

// We are using bit level encoding for a/t/g/c to save memory.
typedef struct {
  unsigned bits:2;
} bit_field;
typedef vector<bit_field> BitStr;

// Comparators

// Operator overloading

#endif  // HEADER_H
