#include <iostream>
#include <algorithm>

using namespace std;

const int MAX = 100;

pair<int, int> intervals[MAX];

typedef struct event_point {
  bool left; // left or right point?
  int id; // id of interval.
  int x; // value of the point.

  bool operator < (const event_point& p) const {
    return x < p.x;
  }
};

event_point ep[2 * MAX];

int main() {
  freopen("median.in", "rt", stdin);
  int n, ne, total;
  while (cin >> n) {
    ne = total = 0;
    for (int i = 0; i < n; ++i) {
      cin >> intervals[i].first >> intervals[i].second;
      if (intervals[i].first > intervals[i].second) {
	swap(intervals[i].first, intervals[i].second);
      }
      ep[ne].left = true;
      ep[ne].id = i;
      ep[ne].x = intervals[i].first;
      ++ne;
      
      ep[ne].left = false;
      ep[ne].id = i;
      ep[ne].x = intervals[i].second;
      ++ne;
      total += intervals[i].second - intervals[i].first + 1;
    }
    sort(ep, ep + ne);
    int median = total / 2 + 1;
    int mv = -1;
    int gone = 0;
    int prev = ep[0].x, thickness = 0;
    for (int i = 0; i < ne; ++i) {
      gone += thickness * (ep[i].x - prev + !ep[i].left);
      if (gone >= median) {
	int end = !ep[i].left ? ep[i].x: ep[i].x - 1;
	mv = end - (gone - median) / thickness;
	break;
      }
      if (ep[i].left) {
	++thickness;
      } else {
	--thickness;
      }
      prev = ep[i].x + !ep[i].left;
    }
    cout << mv << " " << gone << " " << total << endl;
  }
  return 0;
}
