// This is a standalone program to take a bunch of contigs and tries to merge
// them.

#include <iostream>
#include <fstream>

#include "macros.h"
#include "overlap-graph.h"
#include "shorty-string.h"
#include "utils-file.h"
#include "utils-string.h"

int main(int argc, char* argv[]) {
  if (argc != 3) {
    cout << "usage: shorty-merger contigs contigs-out" << endl;
    exit(1);
  }
  fstream* log_ = UtilsFile::OpenFile("test-log", "w");
  fstream* contigs_ = UtilsFile::OpenFile(argv[2], "w");
  fstream* fin = UtilsFile::OpenFile(argv[1], "r");
  OverlapGraph g(-1, MIN_OVERLAP, MIN_SCORE, log_);
  int total = 0;
  int count = 1;
  int a, b, c, d, e;
  ShortyString str;
  //  while ((*fin) >> a >> str >> b >> c >> d >> e) {
  while ((*fin) >> str) {
    if (str[0] == '>') continue;
    str.ReadVotesFromFile(*fin);
    if (str.size() < 50) continue;
    ShortyString left, right;
    str = UtilsString::CutTails(str, &left, &right).GetConfidentClone();
    //if (str.size() < CUT_OFF_LEN) continue;
    g.AddNode(str, count, 0);
    ++total;
    // CAUTION: Sometimes this might be redundant
    g.AddNode(UtilsString::ReverseComplement(str), -count, 0);
    ++total;
    ++count;
  }
  cout << total << endl;
  g.MergeAndCut(false);
  SStrIntIntIntQuadVec contigs;
  g.PrintContigs(&contigs);
  for (int i = 0; i < contigs.size(); ++i) {
    const ShortyString& ss = contigs[i].first.GetConfidentClone();
    *contigs_ << ss << endl;
    ss.PrintScores(*contigs_);
    //    *contigs << Utils::ReverseComplement(contig[i].first) << endl;
  }
  UtilsFile::CloseFile(log_);
  UtilsFile::CloseFile(contigs_);
  UtilsFile::CloseFile(fin);
  return 0;
}
