#include <iostream>
#include <fstream>
#include <hash_map.h>

#include "header.h"
#include "macros.h"
#include "utils-math.h"
#include "utils-string.h"

hash_map<const char*, int> mar2int;
hash_map<int, string> int2mar;

list<int> adj[1 << (EULER_MAR_LEN << 1)];

const int max_size = UtilsMath::PowerOf4(EULER_MAR_LEN);

//int *freq;

bitset<(1 << (EULER_MAR_LEN << 1))> used;

void init() {
  //adj = new list<int>[max_size];
  //freq = new int[max_size];
};

int org_root;

void Visit(int root) {
  if (root == org_root) {
    cout << int2mar[root];
  } else {
    cout << int2mar[root][EULER_MAR_LEN - 1];
  }
  used.set(root);
  list<int>::const_iterator it = adj[root].begin();
  for (; it != adj[root].end(); ++it) {
    if (used[*it]) continue;
    Visit(*it);
  }
}

void Traverse() {
  for (int i = 0; i < max_size; ++i) {
    if (used[i]) continue;
    org_root = i;   
    Visit(i);
    cout << endl;
  }
}

int main(int argc, char* argv[]) {
  string str;
  while (cin >> str) {
    if (str[0] == '>') continue;
    int prev;
    for (int i = 0; i + EULER_MAR_LEN <= str.size(); ++i) {
      int val = UtilsString::String2Int(str, i, EULER_MAR_LEN);
      mar2int[str.substr(i, EULER_MAR_LEN).c_str()] = val;
      int2mar[val] = str.substr(i, EULER_MAR_LEN);
      //++freq[val];
      if (i) {
	adj[prev].push_back(val);
      }
      prev = val;
    }
  }
  for (int i = 0; i < max_size; ++i) {
    adj[i].sort();//begin(), adj[i].end());
    list<int>::iterator it = adj[i].begin();
    if (it != adj[i].end()) ++it;
    while (it != adj[i].end()) {
      list<int>::iterator pit = it;
      --pit;
      if (*pit == *it) adj[i].erase(it);
      else ++it;
    }
  }
  Traverse();
  return 0;
}
