#ifndef SEEDED_READ_H
#define SEEDED_READ_H

#include "shorty-string.h"
#include "header.h"
#include "utils-string.h"

// Class to handle a seeded read
class SeededRead {
 public:
 SeededRead(const ShortyString& str, int id, int gen)
   : str_(str), id_(id), gen_(gen) {
    //#ifdef COLOR_SPACE
    //str_ = UtilsString::Fasta2Solid(str.Str());
    //#endif
  }
  
  // Getter methods.
  ShortyString Str() const { return str_; }
  //  int Gen() const { return gen_; }
  int Id() const { return id_; }
  int Gen() const { return gen_; }
  int Size() const { return str_.size(); }
  //  int Start() const { return start_; }

 private:
  ShortyString str_;
  
  // Own id and reverse complement id.
  int id_;//, rc_id_;

  // Generation id of this seed.
  int gen_;

  // The starting position of the seed, this is relative to its parent.
  //int start_;
};

#endif  //  SEEDED_READ_H
