#include <iostream>
#include <fstream>

#include "utils-file.h"

using namespace std;

void UtilsFile::CloseFile(fstream* f) {
  f->close();
}

void UtilsFile::Log(ostream* f, const string& str) {
  *f << str << endl;
#ifdef DEBUG
  cout << str << endl;
#endif
}

fstream* UtilsFile::OpenFile(const string& path, const string& mode) {
  if (mode == "r") {
    fstream* fin = new fstream(path.c_str(), ios::in);
    // CHECK error conditions.
    return fin;
  }
  if (mode == "w") {
    fstream* fout = new fstream(path.c_str(), ios::out);
    // CHECK error conditions.
    return fout;
  }
  if (mode == "a") {
    fstream* fout = new fstream(path.c_str(), ios::ate);
    // CHECK error conditions.
    return fout;
  }
  return NULL;
}
