#include "utils-math.h"

// template<class RetType, class ContainerType>
// RetType UtilsMath::IthPercentile(int i, ContainerType* c) {
//   double p = i / 100.0;
  
//   // 'nth_element' works in linear time.
//   nth_element(c->begin(), c->begin() + (int)(c->size() * p), c->end());
//     return *(c->begin(), c->begin() + (int)(c->size() * p));
// }

int UtilsMath::MedianOfIntervals(const IntPairVec& v, int* mn, int* mx) {
  assert(v.size());
  vector<median_event_point> ep;
  int total = 0, n = v.size();
  for (int i = 0; i < n; ++i) {
    median_event_point p;
    p.left = true;
    p.id = i;
    p.x = v[i].first;
    ep.push_back(p);

    p.left = false;
    p.id = i;
    p.x = v[i].second;
    ep.push_back(p);

    total += v[i].second - v[i].first + 1;
  }
  sort(ep.begin(), ep.end());
  int median = total / 2 + 1;
  int mv = -1;
  int gone = 0;
  int prev = ep[0].x, thickness = 0;
  for (int i = 0; i < (int)ep.size(); ++i) {
    gone += thickness * (ep[i].x - prev + !ep[i].left);
    if (gone >= median) {
      int end = !ep[i].left ? ep[i].x: ep[i].x - 1;
      mv = end - (gone - median) / thickness;
      break;
    }
    if (ep[i].left) {
      ++thickness;
    } else {
      --thickness;
    }
    prev = ep[i].x + !ep[i].left;
  }

  // Find the intersection of the intervals and store the co-ordinates of the
  // box.
  int x = 0;
  while (ep[x].left && x < ep.size()) ++x;
  --x;
  int y = ep.size() - 1;
  while (!ep[y].left && y >= 0) --y;
  ++y;
  *mn = ep[x].x;
  *mx = ep[y].x;
  return mv;
}

