#ifndef VOTE_H
#define VOTE_H

#include "header.h"

class Vote {
 public:
  Vote();
  Vote(int a, int t, int g, int c);
  Vote(const Vote& v);

  void Inc(base_types bt, int x);
  char MaxBase() const;
  int MaxVote() const;

  sint operator [] (base_types i) const;
  sint& operator [] (base_types i);
  bool operator == (const Vote& v) const;
  bool operator != (const Vote& v) const;
  void operator += (const Vote& v);

  friend istream& operator >> (istream& is, Vote& v);

 private:
  static int MAX_VAL;
  sint base_[BASE_TYPES];  // Be careful so that the count always stays below 1 << 15.
};

#endif  //  VOTE_H
